Option Compare Database
Option Explicit

Option Compare Database
Option Explicit
Private Const xlCenter = &HFFFFEFF4
Private Const xlContinuous = 1
Private Const xlEdgeLeft = 7
Private Const xlEdgeTop = 8
Private Const xlEdgeBottom = 9
Private Const xlEdgeRight = 10

Sub MakeList()
    Dim dbs As Database, tbl As TableDef, fld As Field
    Dim xlApp As Object, wb As Object, ws As Object, ws2 As Object
    Dim StrLSheet As String, NField As Long
    Dim i As Long, k As Long, i1 As Long
    Dim vbPrim As Boolean, vbUni As Boolean, vbInd As Boolean
    Dim NCol As Byte
        
    NCol = 9
    ReDim Capts(1 To NCol) As String
    Capts(1) = ""
    Capts(2) = ""
    Capts(3) = ""
    Capts(4) = " "
    Capts(5) = ""
    Capts(6) = ""
    Capts(7) = ""
    Capts(8) = " "
    Capts(9) = ""
    
    Set xlApp = CreateObject("excel.application")
    xlApp.Visible = True
    xlApp.SheetsInNewWorkbook = 1
    xlApp.Workbooks.Add
    Set wb = xlApp.activeworkbook
    Set ws = wb.sheets(1)
    ws.Name = ""
    k = 0
    StrLSheet = ws.Name
    Set dbs = CurrentDb()
    For Each tbl In dbs.TableDefs
        If tbl.Attributes <> 0 Then GoTo lblNext
        k = k + 1
        wb.sheets.Add After:=wb.sheets(StrLSheet)
        Set ws2 = wb.activesheet
        ws2.Name = Replace(tbl.Name, " ", "_")
        StrLSheet = wb.activesheet.Name
        Call MakeShapka(ws2, NCol, Capts)
        NField = tbl.Fields.Count
        ws.cells(k, 1).Value = tbl.Name
        ReDim fArr(1 To NField, 1 To NCol)
        For i = 0 To NField - 1
            i1 = i + 1
            Set fld = tbl.Fields(i)
            fArr(i1, 1) = fld.Name
            fArr(i1, 2) = FieldType(fld.Type)
            If fld.Type = dbText Then fArr(i1, 3) = fld.Size
            fArr(i1, 4) = fld.DefaultValue
            If fld.Required = True Then fArr(i1, 5) = ""
            If fld.AllowZeroLength = True Then fArr(i1, 6) = ""
            Call IsIndex(vbInd, vbPrim, vbUni, tbl, fld)
            If vbInd = True Then fArr(i1, 7) = ""
            If vbPrim = True Then fArr(i1, 8) = ""
            If vbUni = True Then fArr(i1, 9) = ""
            Set fld = Nothing
        Next i
        ws2.range("A2:I" & (NField + 1)) = fArr
        ws2.Columns("A:I").EntireColumn.AutoFit
        ws2.Columns("A:A").Font.Bold = True
        Set ws2 = Nothing
lblNext:
    Next tbl
    ws.Columns("A:A").EntireColumn.AutoFit
    ws.Columns("A:A").Font.Bold = True
    
    Set fld = Nothing
    Set ws = Nothing
    Set ws2 = Nothing
    Set wb = Nothing
    Set xlApp = Nothing
    Set dbs = Nothing
End Sub

Function FieldType(intType As Integer) As String
   Select Case intType
        Case dbBoolean
           FieldType = ""
        Case dbByte
           FieldType = ""
        Case dbInteger
           FieldType = ""
        Case dbLong
           FieldType = " "
        Case dbCurrency
           FieldType = ""
        Case dbSingle
           FieldType = " "
        Case dbDouble
           FieldType = " "
        Case dbDate
           FieldType = ""
        Case dbText
           FieldType = ""
        Case dbLongBinary
           FieldType = "OLE "
        Case dbMemo
           FieldType = ""
        Case dbGUID
           FieldType = " "
        Case dbNumeric
            FieldType = ""
        Case Else
            FieldType = ""
   End Select
End Function

Sub IsIndex(ByRef vbIndex As Boolean, ByRef vbPrimary As Boolean, ByRef vbUnique As Boolean, ByRef tbl_dat As TableDef, ByRef fld_dat As Field)
    Dim i As Long, NInd As Long, t_ind  As Index
    vbPrimary = False
    vbUnique = False
    vbIndex = False
    NInd = tbl_dat.Indexes.Count
    For i = 0 To NInd - 1
        Set t_ind = tbl_dat.Indexes(i)
        If StrComp(t_ind.Fields(0).Name, fld_dat.Name, vbTextCompare) = 0 Then
            vbIndex = True
            vbPrimary = t_ind.Primary
            vbUnique = t_ind.Unique
        End If
        Set t_ind = Nothing
    Next i
End Sub

Sub MakeShapka(ByRef objSh As Object, ByVal NumCol As Long, ByVal vFName As Variant)
    Dim i As Long
    For i = 1 To NumCol
        With objSh.cells(1, i)
        .Value = vFName(i)
        .Font.Bold = True
        .HorizontalAlignment = xlCenter
        .Borders(xlEdgeLeft).LineStyle = xlContinuous
        .Borders(xlEdgeTop).LineStyle = xlContinuous
        .Borders(xlEdgeBottom).LineStyle = xlContinuous
        .Borders(xlEdgeRight).LineStyle = xlContinuous
        End With
    Next i
End Sub

